CREATE OR REPLACE PROCEDURE LIBERA_CARD_PADRAO(
   P_CDFILIAL   IN CARDADIA.CDFILIAL%TYPE,
   P_DTMESCARD  IN CARDADIA.DTMESCARD%TYPE,
   P_CDOPERADOR IN CARDADIA.CDOPERADOR%TYPE,
   P_NRLISTA    IN LISTA.NRLISTA%TYPE)

IS

   V_NRCARDAPIO VARCHAR2(20);
   V_NRCARDAGRE VARCHAR2(20);
   V_CARDESPEC  VARCHAR2(1);

   /* VARIAVEIS - TABELA DE SERVICO */
   V_QTCOMESTISEG NUMBER;
   V_QTCOMESTITER NUMBER;
   V_QTCOMESTIQUA NUMBER;
   V_QTCOMESTIQUI NUMBER;
   V_QTCOMESTISEX NUMBER;
   V_QTCOMESTISAB NUMBER;
   V_QTCOMESTIDOM NUMBER;
   V_QTCOMESTIFER NUMBER;
   V_QTCLIESTISEG NUMBER;
   V_QTCLIESTITER NUMBER;
   V_QTCLIESTIQUA NUMBER;
   V_QTCLIESTIQUI NUMBER;
   V_QTCLIESTISEX NUMBER;
   V_QTCLIESTISAB NUMBER;
   V_QTCLIESTIDOM NUMBER;
   V_QTCLIESTIFER NUMBER;
   V_QTFUNESTISEG NUMBER;
   V_QTFUNESTITER NUMBER;
   V_QTFUNESTIQUA NUMBER;
   V_QTFUNESTIQUI NUMBER;
   V_QTFUNESTISEX NUMBER;
   V_QTFUNESTISAB NUMBER;
   V_QTFUNESTIDOM NUMBER;
   V_QTFUNESTIFER NUMBER;
   V_QTDOAESTISEG NUMBER;
   V_QTDOAESTITER NUMBER;
   V_QTDOAESTIQUA NUMBER;
   V_QTDOAESTIQUI NUMBER;
   V_QTDOAESTISEX NUMBER;
   V_QTDOAESTISAB NUMBER;
   V_QTDOAESTIDOM NUMBER;
   V_QTDOAESTIFER NUMBER;
   V_QTESTITURNO1 NUMBER;
   V_QTESTITURNO2 NUMBER;
   V_QTESTITURNO3 NUMBER;
   V_QTESTITURNO4 NUMBER;

   V_QTCOMESTICAR NUMBER;
   V_QTCLIESTICAR NUMBER;
   V_QTFUNESTICAR NUMBER;
   V_QTDOAESTICAR NUMBER;

   V_DTFERIFILI DATE; /* DATA FERIADO */

   V_INCTURNO     INTEGER;
   V_CONTCARDAMES INTEGER;

   V_IDCENTRAL VARCHAR2(01);

   V_IDUTCARDPADR VARCHAR2(01);
   V_IDCARDIAUTIL VARCHAR2(01);

   V_CDFILIALEXIST VARCHAR2(04);
   V_NRCARDEXIST   VARCHAR2(10);
   V_IDCARDPADR    VARCHAR2(01);
   V_EXISTCONF     VARCHAR2(04);
   V_EXISTCARDAPIO VARCHAR(04);

BEGIN
   SELECT MAX(IDUTCARDPADR)
      INTO V_IDUTCARDPADR
   FROM PARAMGERAL;
   IF (V_IDUTCARDPADR = 'S') THEN

      SELECT MAX(IDFILCENTPME)
         INTO V_IDCENTRAL
      FROM FILIAL
      WHERE CDFILIAL = P_CDFILIAL;
      IF (V_IDCENTRAL <> 'S') THEN
         RETURN;
      END IF;

      FOR C_SERVICO IN (
         SELECT CDLISTA AS CDSERVFILI
         FROM LISTA
         WHERE (NRLISTA = P_NRLISTA)
         ) LOOP

         /* GRAVAR A CONFIGURACAO DO SERVICO DAS FILIAIS AGREGADAS */
         FOR C_FILIAL_AGREG IN (
            SELECT DISTINCT F.CDFILIAL
            FROM FILIAL F, SERVICO S, CONFCARD C
            WHERE (F.CDFILCENTPME = P_CDFILIAL)           AND
                  (S.CDFILIAL     = F.CDFILIAL)           AND
                  (S.CDSERVFILI   = C_SERVICO.CDSERVFILI) AND
                  (C.CDFILIAL     = S.CDFILIAL)           AND
                  (C.CDSERVFILI   = S.CDSERVFILI)
         )LOOP
            SELECT MAX(CDFILIAL)
               INTO V_EXISTCONF
            FROM CNFCAMES
            WHERE (CDFILIAL     = C_FILIAL_AGREG.CDFILIAL) AND
                  (CDSERVFILI   = C_SERVICO.CDSERVFILI)    AND
                  (DTREFECNFMES = P_DTMESCARD);

            IF(V_EXISTCONF IS NULL) THEN
               INSERT INTO CNFCAMES (
                      CDFILIAL,     CDSERVFILI,   NRSEQCNFMES,
                      DTREFECNFMES, CDTIPOPRAT,   IDOPCCNFMES,
                      IDIMPCNFMES,  NRPAGCNFMES,  VRPERCOMMES,
                      NRORDCNFMES,  DSCOMPLTPMES, IDCONCNFMES,
                      IDTPPRATDOMM, IDTPPRATSEGM, IDTPPRATTERM,
                      IDTPPRATQUAM, IDTPPRATQUIM, IDTPPRATSEXM,
                      IDTPPRATSABM, IDTPPRATFERM)
               SELECT C_FILIAL_AGREG.CDFILIAL, C_SERVICO.CDSERVFILI, NRSEQCNFCARD,
                      P_DTMESCARD,  CDTIPOPRAT,   IDOPCCNFCARD,
                      IDIMPCNFCARD, NRPAGCNFCARD, VRPERCOMCARD,
                      NRORDCNFCARD, DSCOMPLTP, IDCONCNFCARD,
                      NVL(IDTPPRATDOMP, 'S'), NVL(IDTPPRATSEGP, 'S'), NVL(IDTPPRATTERP, 'S'),
                      NVL(IDTPPRATQUAP, 'S'), NVL(IDTPPRATQUIP, 'S'), NVL(IDTPPRATSEXP, 'S'),
                      NVL(IDTPPRATSABP, 'S'), NVL(IDTPPRATFERP, 'S')
               FROM   CONFCARD
               WHERE (CDFILIAL     = C_FILIAL_AGREG.CDFILIAL) AND
                     (CDSERVFILI   = C_SERVICO.CDSERVFILI)    AND
                     (IDVISUTPEXTR = 'S');
            END IF;
         END LOOP;
         /**/

         /* LER O CARDAPIO PADRAO */
         FOR C_CARDADIA IN (

            SELECT C.NRCARDAPIO, C.DTCARDAPIO
            FROM CARDADIA C, CARDAMES CM
            WHERE (C.CDFILIAL   = P_CDFILIAL)           AND
                  (C.CDSERVFILI = C_SERVICO.CDSERVFILI) AND
                  (C.DTMESCARD  = P_DTMESCARD)          AND
                  (C.CDFILIAL   = CM.CDFILIAL(+))       AND
                  (C.CDSERVFILI = CM.CDSERVFILI(+))     AND
                  (C.DTMESCARD  = CM.DTMESCARDAPIO(+))  AND
                  (NVL(CM.IDCARDLIBCENT, 'N') = 'N')

         )LOOP
            FOR C_AGREGADA IN (
               SELECT DISTINCT F.CDFILIAL
               FROM FILIAL F, SERVICO S, CONFCARD C
               WHERE (F.CDFILCENTPME = P_CDFILIAL)           AND
                     (S.CDFILIAL     = F.CDFILIAL)           AND
                     (S.CDSERVFILI   = C_SERVICO.CDSERVFILI) AND
                     (C.CDFILIAL     = S.CDFILIAL)           AND
                     (C.CDSERVFILI   = S.CDSERVFILI)

            )LOOP
               SELECT
                  MAX(DTFERIFILI)
                  INTO V_DTFERIFILI
               FROM
                  FERIFILI
               WHERE
                  (CDFILIAL   = C_AGREGADA.CDFILIAL) AND
                  (DTFERIFILI = C_CARDADIA.DTCARDAPIO);

               SELECT MAX(IDCARDIAUTIL)
                  INTO V_IDCARDIAUTIL
               FROM PARAMPLANEJA
               WHERE (CDFILIAL = C_AGREGADA.CDFILIAL);

               IF NOT ((V_DTFERIFILI IS NOT NULL) AND (V_IDCARDIAUTIL = 'S')) THEN

                  SELECT NVL(SUM(QTCOMESTISEG), 0), NVL(SUM(QTCOMESTITER), 0),
                         NVL(SUM(QTCOMESTIQUA), 0), NVL(SUM(QTCOMESTIQUI), 0), NVL(SUM(QTCOMESTISEX), 0),
                         NVL(SUM(QTCOMESTISAB), 0), NVL(SUM(QTCOMESTIDOM), 0), NVL(SUM(QTCOMESTIFER), 0),
                         NVL(SUM(QTCLIESTISEG), 0), NVL(SUM(QTCLIESTITER), 0), NVL(SUM(QTCLIESTIQUA), 0),
                         NVL(SUM(QTCLIESTIQUI), 0), NVL(SUM(QTCLIESTISEX), 0), NVL(SUM(QTCLIESTISAB), 0),
                         NVL(SUM(QTCLIESTIDOM), 0), NVL(SUM(QTCLIESTIFER), 0), NVL(SUM(QTFUNESTISEG), 0),
                         NVL(SUM(QTFUNESTITER), 0), NVL(SUM(QTFUNESTIQUA), 0), NVL(SUM(QTFUNESTIQUI), 0),
                         NVL(SUM(QTFUNESTISEX), 0), NVL(SUM(QTFUNESTISAB), 0), NVL(SUM(QTFUNESTIDOM), 0),
                         NVL(SUM(QTFUNESTIFER), 0), NVL(SUM(QTDOAESTISEG), 0), NVL(SUM(QTDOAESTITER), 0),
                         NVL(SUM(QTDOAESTIQUA), 0), NVL(SUM(QTDOAESTIQUI), 0), NVL(SUM(QTDOAESTISEX), 0),
                         NVL(SUM(QTDOAESTISAB), 0), NVL(SUM(QTDOAESTIDOM), 0), NVL(SUM(QTDOAESTIFER), 0)
                  INTO V_QTCOMESTISEG, V_QTCOMESTITER,
                       V_QTCOMESTIQUA, V_QTCOMESTIQUI, V_QTCOMESTISEX,
                       V_QTCOMESTISAB, V_QTCOMESTIDOM, V_QTCOMESTIFER,
                       V_QTCLIESTISEG, V_QTCLIESTITER, V_QTCLIESTIQUA,
                       V_QTCLIESTIQUI, V_QTCLIESTISEX, V_QTCLIESTISAB,
                       V_QTCLIESTIDOM, V_QTCLIESTIFER, V_QTFUNESTISEG,
                       V_QTFUNESTITER, V_QTFUNESTIQUA, V_QTFUNESTIQUI,
                       V_QTFUNESTISEX, V_QTFUNESTISAB, V_QTFUNESTIDOM,
                       V_QTFUNESTIFER, V_QTDOAESTISEG, V_QTDOAESTITER,
                       V_QTDOAESTIQUA, V_QTDOAESTIQUI, V_QTDOAESTISEX,
                       V_QTDOAESTISAB, V_QTDOAESTIDOM, V_QTDOAESTIFER
                  FROM
                     SERVICO
                  WHERE
                     (CDFILIAL   = C_AGREGADA.CDFILIAL)  AND
                     (CDSERVFILI = C_SERVICO.CDSERVFILI)
                  GROUP BY
                     CDFILIAL, CDSERVFILI;

                  IF (V_DTFERIFILI IS NULL) THEN
                     SELECT
                        MAX(DTFERICARD)
                        INTO V_DTFERIFILI
                     FROM
                        FERICARD
                     WHERE
                        (CDFILIAL   = C_AGREGADA.CDFILIAL) AND
                        (DTFERICARD = C_CARDADIA.DTCARDAPIO);
                  END IF;

                  IF (V_DTFERIFILI IS NOT NULL) THEN
                      /* Grava comensais para Feriado */
                     V_QTCOMESTICAR := V_QTCOMESTIFER;
                     V_QTCLIESTICAR := V_QTCLIESTIFER;
                     V_QTFUNESTICAR := V_QTFUNESTIFER;
                     V_QTDOAESTICAR := V_QTDOAESTIFER;
                  ELSE
                     /* Grava comensais para os dias da semana (no-feriados) */
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '1' THEN
                        V_QTCOMESTICAR := V_QTCOMESTIDOM;
                        V_QTCLIESTICAR := V_QTCLIESTIDOM;
                        V_QTFUNESTICAR := V_QTFUNESTIDOM;
                        V_QTDOAESTICAR := V_QTDOAESTIDOM;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '2' THEN
                        V_QTCOMESTICAR := V_QTCOMESTISEG;
                        V_QTCLIESTICAR := V_QTCLIESTISEG;
                        V_QTFUNESTICAR := V_QTFUNESTISEG;
                        V_QTDOAESTICAR := V_QTDOAESTISEG;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '3' THEN
                        V_QTCOMESTICAR := V_QTCOMESTITER;
                        V_QTCLIESTICAR := V_QTCLIESTITER;
                        V_QTFUNESTICAR := V_QTFUNESTITER;
                        V_QTDOAESTICAR := V_QTDOAESTITER;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '4' THEN
                        V_QTCOMESTICAR := V_QTCOMESTIQUA;
                        V_QTCLIESTICAR := V_QTCLIESTIQUA;
                        V_QTFUNESTICAR := V_QTFUNESTIQUA;
                        V_QTDOAESTICAR := V_QTDOAESTIQUA;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '5' THEN
                        V_QTCOMESTICAR := V_QTCOMESTIQUI;
                        V_QTCLIESTICAR := V_QTCLIESTIQUI;
                        V_QTFUNESTICAR := V_QTFUNESTIQUI;
                        V_QTDOAESTICAR := V_QTDOAESTIQUI;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '6' THEN
                        V_QTCOMESTICAR := V_QTCOMESTISEX;
                        V_QTCLIESTICAR := V_QTCLIESTISEX;
                        V_QTFUNESTICAR := V_QTFUNESTISEX;
                        V_QTDOAESTICAR := V_QTDOAESTISEX;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '7' THEN
                        V_QTCOMESTICAR := V_QTCOMESTISAB;
                        V_QTCLIESTICAR := V_QTCLIESTISAB;
                        V_QTFUNESTICAR := V_QTFUNESTISAB;
                        V_QTDOAESTICAR := V_QTDOAESTISAB;
                     END IF;
                  END IF;

                  V_INCTURNO := 1;
                  FOR C_TURNO IN(
                     SELECT
                        QTCOMESTTDOM, QTCOMESTTSEG, QTCOMESTTTER,
                        QTCOMESTTQUA, QTCOMESTTQUI, QTCOMESTTSEX,
                        QTCOMESTTSAB, QTCOMESTTFER
                     FROM
                        TURNOSERV
                     WHERE
                        (CDFILIAL   = C_AGREGADA.CDFILIAL)  AND
                        (CDSERVFILI = C_SERVICO.CDSERVFILI)
                     ORDER BY CDTURNO)
                  LOOP
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '1' THEN
                        IF V_INCTURNO = 1 THEN
                           V_QTESTITURNO1 := C_TURNO.QTCOMESTTDOM;
                        END IF;
                        IF V_INCTURNO = 2 THEN
                           V_QTESTITURNO2 := C_TURNO.QTCOMESTTDOM;
                        END IF;
                        IF V_INCTURNO = 3 THEN
                           V_QTESTITURNO3 := C_TURNO.QTCOMESTTDOM;
                        END IF;
                        IF V_INCTURNO = 4 THEN
                           V_QTESTITURNO4 := C_TURNO.QTCOMESTTDOM;
                        END IF;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '2' THEN
                        IF V_INCTURNO = 1 THEN
                           V_QTESTITURNO1 := C_TURNO.QTCOMESTTSEG;
                        END IF;
                        IF V_INCTURNO = 2 THEN
                           V_QTESTITURNO2 := C_TURNO.QTCOMESTTSEG;
                        END IF;
                        IF V_INCTURNO = 3 THEN
                           V_QTESTITURNO3 := C_TURNO.QTCOMESTTSEG;
                        END IF;
                        IF V_INCTURNO = 4 THEN
                           V_QTESTITURNO4 := C_TURNO.QTCOMESTTSEG;
                        END IF;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '3' THEN
                        IF V_INCTURNO = 1 THEN
                           V_QTESTITURNO1 := C_TURNO.QTCOMESTTTER;
                        END IF;
                        IF V_INCTURNO = 2 THEN
                           V_QTESTITURNO2 := C_TURNO.QTCOMESTTTER;
                        END IF;
                        IF V_INCTURNO = 3 THEN
                           V_QTESTITURNO3 := C_TURNO.QTCOMESTTTER;
                        END IF;
                        IF V_INCTURNO = 4 THEN
                           V_QTESTITURNO4 := C_TURNO.QTCOMESTTTER;
                        END IF;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '4' THEN
                        IF V_INCTURNO = 1 THEN
                           V_QTESTITURNO1 := C_TURNO.QTCOMESTTQUA;
                        END IF;
                        IF V_INCTURNO = 2 THEN
                           V_QTESTITURNO2 := C_TURNO.QTCOMESTTQUA;
                        END IF;
                        IF V_INCTURNO = 3 THEN
                           V_QTESTITURNO3 := C_TURNO.QTCOMESTTQUA;
                        END IF;
                        IF V_INCTURNO = 4 THEN
                           V_QTESTITURNO4 := C_TURNO.QTCOMESTTQUA;
                        END IF;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '5' THEN
                        IF V_INCTURNO = 1 THEN
                           V_QTESTITURNO1 := C_TURNO.QTCOMESTTQUI;
                        END IF;
                        IF V_INCTURNO = 2 THEN
                           V_QTESTITURNO2 := C_TURNO.QTCOMESTTQUI;
                        END IF;
                        IF V_INCTURNO = 3 THEN
                           V_QTESTITURNO3 := C_TURNO.QTCOMESTTQUI;
                        END IF;
                        IF V_INCTURNO = 4 THEN
                           V_QTESTITURNO4 := C_TURNO.QTCOMESTTQUI;
                        END IF;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '6' THEN
                        IF V_INCTURNO = 1 THEN
                           V_QTESTITURNO1 := C_TURNO.QTCOMESTTSEX;
                        END IF;
                        IF V_INCTURNO = 2 THEN
                           V_QTESTITURNO2 := C_TURNO.QTCOMESTTSEX;
                        END IF;
                        IF V_INCTURNO = 3 THEN
                           V_QTESTITURNO3 := C_TURNO.QTCOMESTTSEX;
                        END IF;
                        IF V_INCTURNO = 4 THEN
                           V_QTESTITURNO4 := C_TURNO.QTCOMESTTSEX;
                        END IF;
                     END IF;
                     IF TO_CHAR(C_CARDADIA.DTCARDAPIO, 'D') = '7' THEN
                        IF V_INCTURNO = 1 THEN
                           V_QTESTITURNO1 := C_TURNO.QTCOMESTTSAB;
                        END IF;
                        IF V_INCTURNO = 2 THEN
                           V_QTESTITURNO2 := C_TURNO.QTCOMESTTSAB;
                        END IF;
                        IF V_INCTURNO = 3 THEN
                           V_QTESTITURNO3 := C_TURNO.QTCOMESTTSAB;
                        END IF;
                        IF V_INCTURNO = 4 THEN
                           V_QTESTITURNO4 := C_TURNO.QTCOMESTTSAB;
                        END IF;
                     END IF;

                     IF (V_DTFERIFILI IS NOT NULL) THEN
                        IF V_INCTURNO = 1 THEN
                           V_QTESTITURNO1 := C_TURNO.QTCOMESTTFER;
                        END IF;
                        IF V_INCTURNO = 2 THEN
                           V_QTESTITURNO2 := C_TURNO.QTCOMESTTFER;
                        END IF;
                        IF V_INCTURNO = 3 THEN
                           V_QTESTITURNO3 := C_TURNO.QTCOMESTTFER;
                        END IF;
                        IF V_INCTURNO = 4 THEN
                           V_QTESTITURNO4 := C_TURNO.QTCOMESTTFER;
                        END IF;
                     END IF;

                     V_INCTURNO := V_INCTURNO + 1;

                  END LOOP;

                  SELECT MAX(CDFILIAL), MAX(NRCARDAPIO), MAX(IDCARDIAESPE)
                  INTO V_EXISTCARDAPIO, V_NRCARDAGRE, V_CARDESPEC
                  FROM CARDADIA
                  WHERE (CDFILIAL   = C_AGREGADA.CDFILIAL)  AND
                        (CDSERVFILI = C_SERVICO.CDSERVFILI) AND
                        (DTCARDAPIO = C_CARDADIA.DTCARDAPIO);

                  /*Exclui cardpio no especfico caso o mesmo seja liberado mais de uma vez*/
                  IF (V_EXISTCARDAPIO IS NOT NULL) AND ((V_CARDESPEC IS NULL) OR (V_CARDESPEC = 'N')) THEN
                     DELETE FROM COMPCARD
                     WHERE CDFILIAL   = C_AGREGADA.CDFILIAL AND
                           NRCARDAPIO = V_NRCARDAGRE;

                     DELETE FROM CARDADIA
                     WHERE CDFILIAL   = C_AGREGADA.CDFILIAL AND
                           NRCARDAPIO = V_NRCARDAGRE;

                     V_EXISTCARDAPIO := NULL;
                  END IF;
                  /***************************************************************************/

                  IF (V_EXISTCARDAPIO IS NULL) THEN
                     NOVO_CODIGO_SC('CARDAPIO'||C_AGREGADA.CDFILIAL, V_NRCARDAPIO, 1);
                     V_NRCARDAPIO := SUBSTR(V_NRCARDAPIO, 11, 10);

                     IF (V_QTCOMESTICAR > 0) THEN
                        INSERT INTO CARDADIA(CDFILIAL,     NRCARDAPIO,   CDSERVFILI,
                                             CDOPERADOR,   DTCARDAPIO,   DTMESCARD,
                                             QTCOMESTICAR, QTESTITURNO1, QTESTITURNO2,
                                             QTESTITURNO3, QTESTITURNO4, QTCLIESTICAR,
                                             QTFUNESTICAR, QTDOAESTICAR)
                        VALUES(C_AGREGADA.CDFILIAL,
                               SUBSTR(V_NRCARDAPIO, 1, 10),
                               C_SERVICO.CDSERVFILI,
                               P_CDOPERADOR,
                               C_CARDADIA.DTCARDAPIO,
                               P_DTMESCARD,
                               V_QTCOMESTICAR,
                               V_QTESTITURNO1,
                               V_QTESTITURNO2,
                               V_QTESTITURNO3,
                               V_QTESTITURNO4,
                               V_QTCLIESTICAR,
                               V_QTFUNESTICAR,
                               V_QTDOAESTICAR);

                        INSERT INTO COMPCARD(
                               CDFILIAL,     NRCARDAPIO, NRSEQPRATCAR,
                               CDFILAUXPRAT, CDPRATO,    VRPECONSCARD,
                               QTSOBRLIMPPR, CDTIPOPRAT, QTCOMEFETPRA,
                               QTPRODUZPRAT, NRORDPRATCAR)
                        SELECT C_AGREGADA.CDFILIAL, SUBSTR(V_NRCARDAPIO, 1, 10), P.NRSEQPRATCAR,
                               PRA.CDFILAUXPRAT, P.CDPRATO, P.VRPECONSCARD + NVL(ACRESCENTAR.VALOR, 0),
                               P.QTSOBRLIMPPR, P.CDTIPOPRAT, P.QTCOMEFETPRA,
                               P.QTPRODUZPRAT, P.NRORDPRATCAR
                        FROM COMPCARD P, CARDADIA C, CNFCAMES F, PRATO PRC, PRATO PRA,
                             (SELECT A.CDTIPOPRAT, DECODE (QT.QTTIPOPRATOS, 0, 0, A.SOMAPERC / QT.QTTIPOPRATOS) AS VALOR
                              FROM (SELECT CC.CDTIPOPRAT,
                                           SUM(CC.VRPECONSCARD) AS SOMAPERC
                                    FROM   CARDADIA C, COMPCARD CC
                                    WHERE  C.CDFILIAL    = P_CDFILIAL            AND
                                           C.NRCARDAPIO  = C_CARDADIA.NRCARDAPIO AND
                                           CC.CDFILIAL   = C.CDFILIAL            AND
                                           CC.NRCARDAPIO = C.NRCARDAPIO          AND
                                           NOT EXISTS (SELECT CF.CDTIPOPRAT
                                                       FROM   CNFCAMES CF
                                                       WHERE  CF.CDFILIAL     = C_AGREGADA.CDFILIAL  AND
                                                              CF.CDSERVFILI   = C_SERVICO.CDSERVFILI AND
                                                              CF.DTREFECNFMES = P_DTMESCARD          AND
                                                              CF.NRSEQCNFMES  = CC.NRSEQPRATCAR      AND
                                                              'S' = DECODE (V_DTFERIFILI, NULL,
                                                                            DECODE (TO_CHAR(C.DTCARDAPIO, 'D'),
                                                                                           '1', CF.IDTPPRATDOMM,
                                                                                           '2', CF.IDTPPRATSEGM,
                                                                                           '3', CF.IDTPPRATTERM,
                                                                                           '4', CF.IDTPPRATQUAM,
                                                                                           '5', CF.IDTPPRATQUIM,
                                                                                           '6', CF.IDTPPRATSEXM,
                                                                                           '7', CF.IDTPPRATSABM),
                                                                            CF.IDTPPRATFERM))
                                    GROUP BY CC.CDTIPOPRAT) A,
                                   (SELECT
                                       CF.CDTIPOPRAT,
                                       COUNT(CF.CDTIPOPRAT) AS QTTIPOPRATOS
                                    FROM
                                       CARDADIA C,
                                       CNFCAMES CF
                                    WHERE
                                       C.CDFILIAL   = C_AGREGADA.CDFILIAL         AND
                                       C.NRCARDAPIO = SUBSTR(V_NRCARDAPIO, 1, 10) AND
                                       C.CDFILIAL   = CF.CDFILIAL                 AND
                                       C.CDSERVFILI = CF.CDSERVFILI               AND
                                       C.DTMESCARD  = CF.DTREFECNFMES             AND
                                       'S' = DECODE (V_DTFERIFILI, NULL,
                                                     DECODE (TO_CHAR(C.DTCARDAPIO, 'D'),
                                                                    '1', CF.IDTPPRATDOMM,
                                                                    '2', CF.IDTPPRATSEGM,
                                                                    '3', CF.IDTPPRATTERM,
                                                                    '4', CF.IDTPPRATQUAM,
                                                                    '5', CF.IDTPPRATQUIM,
                                                                    '6', CF.IDTPPRATSEXM,
                                                                    '7', CF.IDTPPRATSABM),
                                                     CF.IDTPPRATFERM)
                                    GROUP BY
                                       CF.CDTIPOPRAT) QT
                              WHERE
                                 A.CDTIPOPRAT = QT.CDTIPOPRAT) ACRESCENTAR
                        WHERE (C.CDFILIAL     = P_CDFILIAL)            AND
                              (C.NRCARDAPIO   = C_CARDADIA.NRCARDAPIO) AND
                              (P.CDFILIAL     = C.CDFILIAL)            AND
                              (P.NRCARDAPIO   = C.NRCARDAPIO)          AND
                              (F.CDFILIAL     = C_AGREGADA.CDFILIAL)   AND
                              (F.CDSERVFILI   = C.CDSERVFILI)          AND
                              (F.NRSEQCNFMES  = P.NRSEQPRATCAR)        AND
                              (F.DTREFECNFMES = P_DTMESCARD)           AND
                              (F.CDTIPOPRAT   = P.CDTIPOPRAT)          AND
                              (P.CDTIPOPRAT   = ACRESCENTAR.CDTIPOPRAT(+)) AND
                              (pra.cdprato = p.cdprato) and
                              (pra.cdfilauxprat in ('P', C_AGREGADA.CDFILIAL)) and
                              (prc.cdprato = p.cdprato) and
                              (prc.cdfilauxprat in ('P', P_CDFILIAL)) and
                              (prc.nmprato = pra.nmprato) and
                              ('S' = DECODE (V_DTFERIFILI, NULL,
                                             DECODE (TO_CHAR(C.DTCARDAPIO, 'D'),
                                                            '1', F.IDTPPRATDOMM,
                                                            '2', F.IDTPPRATSEGM,
                                                            '3', F.IDTPPRATTERM,
                                                            '4', F.IDTPPRATQUAM,
                                                            '5', F.IDTPPRATQUIM,
                                                            '6', F.IDTPPRATSEXM,
                                                            '7', F.IDTPPRATSABM),
                                             F.IDTPPRATFERM));
                     END IF;
                  END IF;
               END IF;
            END LOOP;
         END LOOP;
      END LOOP;
   END IF;

   FOR C_SERVICO IN (SELECT CDLISTA AS CDSERVFILI
                     FROM LISTA
                     WHERE (NRLISTA = P_NRLISTA)) LOOP

      /*Select criado para verificar se existe o registro na tabela CARDAMES. Caso exista,
        edita o registro informando a data de referncia. Caso contrrio, insere o registro na tabela.*/
      SELECT COUNT(*) AS CONTCARDAMES
      INTO V_CONTCARDAMES
      FROM CARDAMES
      WHERE (CDFILIAL      = P_CDFILIAL          )
        AND (CDSERVFILI    = C_SERVICO.CDSERVFILI)
        AND (DTMESCARDAPIO = P_DTMESCARD         );

      IF V_CONTCARDAMES > 0 THEN
         UPDATE CARDAMES
         SET DTREFECUSTMES = TRUNC(SYSDATE), IDCARDLIBCENT = 'S'
         WHERE (CDFILIAL      = P_CDFILIAL          )
           AND (CDSERVFILI    = C_SERVICO.CDSERVFILI)
           AND (DTMESCARDAPIO = P_DTMESCARD         );
      ELSE
         INSERT INTO CARDAMES
            (CDFILIAL, CDSERVFILI, DTMESCARDAPIO, DTREFECUSTMES, IDCARDLIBCENT)
         VALUES
            (P_CDFILIAL, C_SERVICO.CDSERVFILI, P_DTMESCARD, TRUNC(SYSDATE), 'S');
      END IF;
   END LOOP;

   DELETE FROM CTRLAPROVCARD
   WHERE
      (CDFILIAL        = P_CDFILIAL ) AND
      (DTMESCARDAPROV  = P_DTMESCARD) AND
      EXISTS
         (SELECT CDFILIAL
          FROM LISTA
          WHERE (CDSERVFILI = CDLISTA    ) AND
                (NRLISTA    = P_NRLISTA  )
      );

   INSERT INTO CTRLAPROVCARD
      (CDFILIAL, CDSERVFILI, DTMESCARDAPROV, DTLIBECARDMATR, CDOPERAPROCARDFILI)
   SELECT
      P_CDFILIAL, CDLISTA, P_DTMESCARD, TRUNC(SYSDATE), P_CDOPERADOR
   FROM
      LISTA
   WHERE
      (NRLISTA    = P_NRLISTA  );


   DELETE FROM LISTA
   WHERE NRLISTA = P_NRLISTA;

   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LIBERA_CARD_PADRAO','5.03.006'); END;
/

